Subject: [hybi] [Technical Errata Reported] RFC6455 (3433)

From: RFC Errata System <[email-masked]>
Date: Thu, 20 Dec 2012 16:02:31 -0800 (PST)

The following errata report has been submitted for RFC6455,
"The WebSocket Protocol".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata_search.php?rfc=6455&eid=3433

--------------------------------------
Type: Technical
Reported by: Eric Lawrence <[email-masked]>

Section: 11.3.2

Original Text
-------------
However, the |Sec-WebSocket-Extensions| header field MUST NOT appear more than once in an HTTP response.

Corrected Text
--------------
The |Sec-WebSocket-Extensions| header field MAY appear multiple times in an HTTP response (which is logically the same as a single |Sec-WebSocket-Extensions| header field that contains all values).

Notes
-----
Section 4.2.2 Step 5 subpart 6 (top of page 25) clearly explains that this header field may appear multiple times in the server's response: "If multiple extensions are to be used, they can all be listed in a single |Sec-WebSocket-Extensions| header field or split between multiple instances of the |Sec-WebSocket-Extensions| header field. This completes the server's handshake..."

Instructions:
-------------
This errata is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party (IESG)
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC6455 (draft-ietf-hybi-thewebsocketprotocol-17)
--------------------------------------
Title               : The WebSocket Protocol
Publication Date    : December 2011
Author(s)           : I. Fette, A. Melnikov
Category            : PROPOSED STANDARD
Source              : BiDirectional or Server-Initiated HTTP
Area                : Applications
Stream              : IETF
Verifying Party     : IESG

---

From: Takeshi Yoshino <[email-masked]>
Date: Fri, 21 Dec 2012 13:41:14 +0900

+1

Both "If multiple ..." and "However, the ..." were added from
https://tools.ietf.org/html/draft-ietf-hybi-thewebsocketprotocol-14.

In the release note by Alexey (
http://www.ietf.org/mail-archive/web/hybi/current/msg08863.html), it's said
> Clarified that some header fields can appear multiple times. (per WG
discussion)

This is the thread where the decision was made (multiple headers are
allowed)
http://www.ietf.org/mail-archive/web/hybi/current/msg08690.html

I think it was just cut n' pasted but left not updated. IIRC, we didn't
have any discussion to add asymmetric constraints like this.

There were similar bug which was fixed on -15 release.
http://www.ietf.org/mail-archive/web/hybi/current/msg09057.html

Takeshi

On Fri, Dec 21, 2012 at 9:02 AM, RFC Errata System <
[email-masked]> wrote:

> The |Sec-WebSocket-Extensions| header field MAY appear multiple times in
> an HTTP response (which is logically the same as a single
> |Sec-WebSocket-Extensions| header field that contains all values).
>
>
> Notes
> -----
> Section 4.2.2 Step 5 subpart 6 (top of page 25) clearly explains that this
> header field may appear multiple times in the server's response: "If
> multiple extensions are to be used, they can all be listed in a single
> |Sec-WebSocket-Extensions| header field or split between multiple instances
> of the |Sec-WebSocket-Extensions| header field. This completes the server's
> handshake..."
>
> Instructions:
> -------------
> _______________________________________________
> hybi mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/hybi
>

---

From: Alexey Melnikov <[email-masked]>
Date: Sat, 22 Dec 2012 09:56:44 +0000

On 21/12/2012 04:41, Takeshi Yoshino wrote:
> In the release note by Alexey 
> (http://www.ietf.org/mail-archive/web/hybi/current/msg08863.html), it's said
> I think it was just cut n' pasted but left not updated. IIRC, we 
> didn't have any discussion to add asymmetric constraints like this.
>

Thanks, Takeshi. I agree that the erratum should be approved.

> Takeshi
>
>
> On Fri, Dec 21, 2012 at 9:02 AM, RFC Errata System 
> <[email-masked] <mailto:[email-masked]>> wrote:
>
>
>     Reported by: Eric Lawrence <[email-masked]
>     <mailto:[email-masked]>>
>
>     Section: 11.3.2
>
>     Original Text
>     -------------
>     However, the |Sec-WebSocket-Extensions| header field MUST NOT
>     appear more than once in an HTTP response.
>
>
>     Corrected Text
>     --------------
>     The |Sec-WebSocket-Extensions| header field MAY appear multiple
>     times in an HTTP response (which is logically the same as a single
>     Section 4.2.2 Step 5 subpart 6 (top of page 25) clearly explains
>     that this header field may appear multiple times in the server's
>     response: "If multiple extensions are to be used, they can all be
>     listed in a single |Sec-WebSocket-Extensions| header field or
>     split between multiple instances of the |Sec-WebSocket-Extensions|
>     header field. This completes the server's handshake..."
>
>     Instructions:
>     -------------
>     [email-masked] <mailto:[email-masked]>

---

From: Barry Leiba <[email-masked]>
Date: Sat, 22 Dec 2012 11:20:00 -0500

> Thanks, Takeshi. I agree that the erratum should be approved.

And now it has been.

Barry, responsible AD